# !/usr/bin/python
# -*- coding: <UTF-8> -*-

"""
Python Version : 3.6

$LastChangedRevision: 5146 $
$LastChangedDate:: 2021-11-03 08:22:53 +0100#$

This file is part of SyMSpace.

Copyright (c) 2020, Linz Center of Mechatronics GmbH (LCM) http://www.lcm.at/
All rights reserved.
"""
import numpy as np
from heroku_server import HerokuServer


def run_fnc(input_data, logger=None) -> dict:
    logger.info("Calculating ...")
    a = input_data['a']
    b = input_data['b']
    c = np.sqrt(a**2 + b**2)
    logger.info("Calculating done")
    output_data = {'c': c}
    return output_data


if __name__ == "__main__":
    _debug = False

    if _debug:
        _debug_uri = "localhost"
        _debug_port = 5000
        _hs = HerokuServer(_debug_uri, _debug_port)
    else:
        _hs = HerokuServer()

    HerokuServer.set_run_fnc(run_fnc)
    _hs.start()
