import sys
import numpy as np
import matplotlib.pyplot as plt
import os
import camelot  # pip install camelot-py
                # pip install opencv-python
import glob
import pandas as pd
import xlrd
import re
import json

import matplotlib.pyplot as plt
from matplotlib.font_manager import FontProperties

H_original = np.array([0, 0.41, 0.54, 0.71, 0.81, 0.94, 1.08, 1.24, 1.42, 1.64, 1.88, 2.17, 2.49, 2.86, 3.29, 3.79, 4.36, 5.01, 6.63, 7.62, 8.76, 10.08, 11.59, 13.33, 15.33, 17.63, 20.27, 23.31, 26.8, 30.55, 35.14, 40.41, 46.48, 61.48, 70.71, 81.32, 93.52, 107.6, 123.7, 142.2, 163.6, 188.1, 248.8, 286.1, 329, 378.2, 501, 576.1, 662.4, 761.7])
B_original = np.array([0, 0.001, 0.005, 0.009, 0.012, 0.015, 0.018, 0.021, 0.025, 0.031, 0.036, 0.04, 0.06, 0.08, 0.11, 0.16, 0.23, 0.28, 0.35, 0.48, 0.54, 0.6, 0.66, 0.71, 0.76, 0.8, 0.84, 0.88, 0.91, 0.93, 0.96, 0.99, 1.01, 1.05, 1.07, 1.09, 1.11, 1.13, 1.15, 1.17, 1.19, 1.21, 1.25, 1.27, 1.29, 1.31, 1.36, 1.38, 1.4, 1.42])

H_extrapolated = np.array([0, 0.41, 0.54, 0.71, 0.81, 0.94, 1.08, 1.24, 1.42, 1.64, 1.88, 2.17, 2.49, 2.86, 3.29, 3.79, 4.36, 5.01, 6.63, 7.62, 8.76, 10.08, 11.59, 13.33, 15.33, 17.63, 20.27, 23.31, 26.8, 30.55, 35.14, 40.41, 46.48, 61.48, 70.71, 81.32, 93.52, 107.6, 123.7, 142.2, 163.6, 188.1, 248.8, 286.1, 329, 378.2, 501, 576.1, 662.4, 761.7, 1000, 2000, 4000, 6000, 8000, 10000, 15000, 20000, 40000, 60000, 80000, 100000, 500000])
B_extrapolated = np.array([0, 0.001, 0.005, 0.009, 0.012, 0.015, 0.018, 0.021, 0.025, 0.031, 0.036, 0.04, 0.06, 0.08, 0.11, 0.16, 0.23, 0.28, 0.35, 0.48, 0.54, 0.6, 0.66, 0.71, 0.76, 0.8, 0.84, 0.88, 0.91, 0.93, 0.96, 0.99, 1.01, 1.05, 1.07, 1.09, 1.11, 1.13, 1.15, 1.17, 1.19, 1.21, 1.25, 1.27, 1.29, 1.31, 1.36, 1.38, 1.4, 1.42, 1.434365318, 1.458690218, 1.473018374, 1.479512663, 1.484024553, 1.487739603, 1.495628209, 1.502715416, 1.529055832, 1.55459157, 1.579925892, 1.605179609, 2.108221686])

mu_0 = 4 * np.pi * 1e-7

fontP = FontProperties()
fontP.set_size('small')
fig2 = plt.figure()

# fig2.figsize(15,25)
fig2.set_figheight(20)
fig2.set_figwidth(15)

ax1 = fig2.add_subplot(311)  # ,figsize=(15,15))
ax1.grid(True)
ax1.set_title(r'$Curve \ for \ FE \ simulation \ vs. \ measurement$')  # "Curve for FE simulation")
ax1.set_xlabel(r"$H [A/m]$")
ax1.set_ylabel(r"$B [T]$")

max_h = H_original[-1]
max_b = B_original[-1]
ax1.set_xlim(-100, max_h * 1.1)
ax1.set_ylim(0, max_b * 1.1)

plt.plot(H_original, B_original, "ro")
plt.plot(H_extrapolated, B_extrapolated, "b-")

box = ax1.get_position()
ax1.set_position([box.x0, box.y0, box.width * 0.8, box.height])
ax1.legend(prop=fontP, loc='center left', bbox_to_anchor=(1, 0.5))

ax2 = fig2.add_subplot(312)
ax2.grid(True)
ax2.set_title(r'$\mu_r-Curve$')
ax2.set_xlabel(r"$B [T]$")
ax2.set_ylabel(r"$\mu_{r} [1]$")

mu_r = B_extrapolated[1:] / H_extrapolated[1:] / mu_0
mu_r = np.append(0, mu_r)

ax2.set_xlim(0, max_b * 1.1)
ax2.set_ylim(0, max(mu_r) * 1.1)

plt.plot(B_extrapolated, mu_r)

box = ax2.get_position()
ax2.set_position([box.x0, box.y0, box.width * 0.8, box.height])
ax2.legend(prop=fontP, loc='center left', bbox_to_anchor=(1, 0.5))

ax3 = fig2.add_subplot(313)
ax3.grid(True)
ax3.set_title(r'$BH-Curve \ for \ FE \ simulation$')  # "Curve for FE simulation")
ax3.set_xlabel(r"$H [A/m]$")
ax3.set_ylabel(r"$B [T]$")

max_h = H_extrapolated[-1]
max_b = B_extrapolated[-1]

ax3.set_xlim(-4000, max_h * 1.1)
ax3.set_ylim(0, max_b * 1.1)

# plt.plot(material_dictionary['H_original'][0], material_dictionary['B_original'][0], "ro")
plt.plot(H_extrapolated, B_extrapolated, "b-")

box = ax3.get_position()
ax3.set_position([box.x0, box.y0, box.width * 0.8, box.height])
ax3.legend(prop=fontP, loc='center left', bbox_to_anchor=(1, 0.5))

# sio.savemat('\Mat_' + name + '_SimCurves.mat', mdict={'vals': initial_curveMod})

fig2.tight_layout()
# fig2.subplots_adjust(hspace=1.0, wspace=1.0)

fig2.show()
fig2.savefig("bhcurve_plot.png")